`timescale 1 ns / 1 ns 

module tb_dac();
  logic signed [15:0] dataIn;
  logic dataOut;
  logic ck, clk_enable;
  logic rst;
  logic ce_out; 
  
  logic signed [15:0] data;
  int f, sin, scan_file, nmbSamplesOut, Nfft;
  logic eof = 0;
  time CK_PERIOD = 177ns;
  
  dac dut(.ck(ck),
          .ck_enable(clk_enable),
          .rst(rst),
          .sdInternalRst(0),
          .dataIn(dataIn),
          .dataOut(dataOut),
          .ce_out(ce_out)
          );
  
  initial begin
    $display("Testbench starting!!");
    f = $fopen("output.txt","w");
    sin = $fopen("sinus4kfs44100.txt","r");
    ck = 0;
    dataIn = 0;
    clk_enable = 0;
    Nfft = 44100*128;
    rst = 1;
    #(10*CK_PERIOD);
    rst = 0;
  end  
    
  
  always begin
    #CK_PERIOD ck = ~ck;
  end
 
  initial begin
  scan_file = $fscanf(sin, "%d", data); 
  dataIn = data;
    
  @(negedge rst);
  
  fork
    begin
      $display("Starting to send samples to DAC");
      clk_enable = 1;
      eof = $feof(sin);
      while(eof == 0) begin
        scan_file = $fscanf(sin, "%d", data); 
        eof = $feof(sin);
        @(posedge ce_out);
        dataIn = data;
      end
      //clk_enable = 0;
      @(posedge ce_out);
      dataIn = 0;
      $display("Finished sending samples to DAC");
    end
    begin
      nmbSamplesOut = 0;
      while(nmbSamplesOut < Nfft) begin
        @(posedge ck)
        if(dataOut == 0)
          $fwrite(f,"%0d ",-1);
        else
          $fwrite(f,"%d ",dataOut);
        nmbSamplesOut++;
      end
    end
  join
  @(posedge ck)
  #1ns;
  disable fork;
  
  $fclose(sin);
  $fclose(f);
  $display("Testbench finished!!");
  $finish;
  end
  
endmodule
