`timescale 1ns / 1ps

module RegTasks #(
    parameter DATA_WIDTH = 32
    )(
    input  logic ck,
    input  logic arst,
    input  logic [DATA_WIDTH-1:0] ctrlReg,
    output logic taskCkEn,
    output logic taskStabConEn
    );
    
    always_ff @(posedge ck or posedge arst) begin
        if(arst) 
            begin
                taskCkEn <=0;
                taskStabConEn <= 0;
            end
        else 
            begin 
                taskCkEn <= ctrlReg[0];
                taskStabConEn <= ctrlReg[0] & ctrlReg[1];
            end
    end  
endmodule
