

/***************************** Include Files *******************************/
#include "SD_DAC.h"
#include "xil_io.h"
/************************** Function Definitions ***************************/


s32 SD_DAC_readReg(int BaseAddress, int RegNum, u32 *readData){
	s32 Status = XST_SUCCESS;

	switch(RegNum) {
	   case 0  :
		  *readData = SD_DAC_mReadReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG0_OFFSET);
	      break;

	   case 1  :
		   *readData = SD_DAC_mReadReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG1_OFFSET);
	      break;

	   case 2  :
		   *readData = SD_DAC_mReadReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG2_OFFSET);
	   	  break;

	   case 3 :
		   *readData = SD_DAC_mReadReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG3_OFFSET);
	   	  break;

	   default :
		  Status = XST_FAILURE; //Wrong RegNum
	}
	return Status;
}

s32 SD_DAC_writeReg(int BaseAddress, int RegNum, int writeData){
	s32 Status = XST_SUCCESS;

	switch(RegNum) {
	   case 0  :
		  SD_DAC_mWriteReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG0_OFFSET, writeData);
	      break;

	   case 1  :
		   SD_DAC_mWriteReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG1_OFFSET, writeData);
	      break;

	   case 2  :
		   SD_DAC_mWriteReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG2_OFFSET, writeData);
	   	  break;

	   case 3 :
		   SD_DAC_mWriteReg(BaseAddress, SD_DAC_S00_AXI_SLV_REG3_OFFSET, writeData);
	   	  break;

	   default :
		  Status = XST_FAILURE; //Wrong RegNum
	}
	return Status;
}

s32 SD_DAC_startTask(int BaseAddress){
	s32 Status = XST_SUCCESS;
	u32 readData, writeData;

	SD_DAC_readReg(BaseAddress, 0, &readData);
	writeData = readData+(1<<0); //Set bit 0 to one to start SD-DAC
	SD_DAC_writeReg(BaseAddress, 0, writeData);

	return Status;
}

s32 SD_DAC_stopTask(int BaseAddress){
	s32 Status = XST_SUCCESS;
	u32 readData, writeData;
	u32 bitMask = 4294967294;

	SD_DAC_readReg(BaseAddress, 0, &readData);
	writeData = readData & bitMask; //Set bit 0 to zero to stop SD-DAC
	SD_DAC_writeReg(BaseAddress, 0, writeData);

	return Status;
}





