
#ifndef SD_DAC_H
#define SD_DAC_H


/****************** Include Files ********************/
#include "xil_types.h"
#include "xstatus.h"

#define SD_DAC_S00_AXI_SLV_REG0_OFFSET 0
#define SD_DAC_S00_AXI_SLV_REG1_OFFSET 4
#define SD_DAC_S00_AXI_SLV_REG2_OFFSET 8
#define SD_DAC_S00_AXI_SLV_REG3_OFFSET 12


/**************************** Type Definitions *****************************/
/**
 *
 * Write a value to a SD_DAC register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the SD_DACdevice.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void SD_DAC_mWriteReg(u32 BaseAddress, unsigned RegOffset, u32 Data)
 *
 */
#define SD_DAC_mWriteReg(BaseAddress, RegOffset, Data) \
  	Xil_Out32((BaseAddress) + (RegOffset), (u32)(Data))

/**
 *
 * Read a value from a SD_DAC register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the SD_DAC device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	u32 SD_DAC_mReadReg(u32 BaseAddress, unsigned RegOffset)
 *
 */
#define SD_DAC_mReadReg(BaseAddress, RegOffset) \
    Xil_In32((BaseAddress) + (RegOffset))

/************************** Function Prototypes ****************************/
/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the SD_DAC instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus SD_DAC_Reg_SelfTest(void * baseaddr_p);


s32 SD_DAC_readReg(int BaseAddress, int RegNum, u32 *readData);
s32 SD_DAC_writeReg(int BaseAddress, int RegNum, int writeData);
s32 SD_DAC_startTask(int BaseAddress);
s32 SD_DAC_stopTask(int BaseAddress);
s32 SD_DAC_startStabConUnitTask(int BaseAddress);
s32 SD_DAC_stopStabConUnitTask(int BaseAddress);


#endif // SD_DAC_H
