`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/07/2017 03:20:55 PM
// Design Name: 
// Module Name: StabilityControlUnit
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module StabilityControlUnit #(parameter UNSTABLE_COUNT  = 30,
                              parameter COUNT_LENGTH = $clog2(UNSTABLE_COUNT)
                             )
                             (
                             input logic ck,
                             input logic rst,
                             input logic enable,
                             input logic sdOut,
                             output logic dacRst
                             );
    
    logic [COUNT_LENGTH:0] count; 
    logic oldValue;
    
    always @(posedge ck) begin : Counter 
        if(rst) 
            begin 
                count <= 0; 
                oldValue <= 0;
            end
        else
            begin 
                if(enable)
                    begin    
                        oldValue <= sdOut;
                        if(oldValue == 1'b1 &&  sdOut == 1'b1)
                            begin
                                count <= count +1;
                            end
                        else if(oldValue == 1'b0 &&  sdOut == 1'b0)
                            begin
                                count <= count +1;
                            end
                        else
                            begin
                                count <= 0;
                            end 
                    end
            end 
    end 
    
    always @(posedge ck) begin : syncResetAssertion
        if(rst) 
            begin
                dacRst <= 0; 
            end
        else
            begin 
                if(count > UNSTABLE_COUNT)  
                    begin 
                        dacRst <= 1;
                    end
            end
     end   
    
    
endmodule
