#
# Vivado (TM) v2016.4 (64-bit)
#
# DAC-FPGA.tcl: Tcl script for re-creating project 'DAC-FPGA'
#
# Generated by Vivado on Thu Mar 09 13:32:09 CET 2017
# IP Build 1755317 on Mon Jan 23 20:30:07 MST 2017
#
# This file contains the Vivado Tcl commands for re-creating the project to the state*
# when this script was generated. In order to re-create the project, please source this
# file in the Vivado Tcl Shell.
#
# * Note that the runs in the created project will be configured the same way as the
#   original project, however they will not be launched automatically. To regenerate the
#   run results please launch the synthesis/implementation runs as needed.
#
#*****************************************************************************************
# NOTE: In order to use this script for source control purposes, please make sure that the
#       following files are added to the source control system:-
#
# 1. This project restoration tcl script (DAC-FPGA.tcl) that was generated.
#
# 2. The following source(s) files that were local or imported into the original project.
#    (Please see the '$orig_proj_dir' and '$origin_dir' variable setting below at the start of the script)
#
#    <none>
#
# 3. The following remote source files that were added to the original project:-
#
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/DacFpga.bd"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/hdl/DacFpga_wrapper.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage1.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage3.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage5.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage4.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage2.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage6.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_stage7.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/SDmod/SDmod.sv"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC/dac.sv"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/tb_if.sv"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/HdlFilterOpt/casfilt_tb.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/SDmod/tb_SDmod.sv"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/SDmod/casfilt_tb.v"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/constrs_1/new/DAC_PL_clock.xdc"
#    "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC/tb_dac.sv"
#
#*****************************************************************************************

# Set the reference directory for source file relative paths (by default the value is script directory path)
set origin_dir "."

# Use origin directory path location variable, if specified in the tcl shell
if { [info exists ::origin_dir_loc] } {
  set origin_dir $::origin_dir_loc
}

variable script_file
set script_file "DAC-FPGA.tcl"

# Help information for this script
proc help {} {
  variable script_file
  puts "\nDescription:"
  puts "Recreate a Vivado project from this script. The created project will be"
  puts "functionally equivalent to the original project for which this script was"
  puts "generated. The script contains commands for creating a project, filesets,"
  puts "runs, adding/importing sources and setting properties on various objects.\n"
  puts "Syntax:"
  puts "$script_file"
  puts "$script_file -tclargs \[--origin_dir <path>\]"
  puts "$script_file -tclargs \[--help\]\n"
  puts "Usage:"
  puts "Name                   Description"
  puts "-------------------------------------------------------------------------"
  puts "\[--origin_dir <path>\]  Determine source file paths wrt this path. Default"
  puts "                       origin_dir path value is \".\", otherwise, the value"
  puts "                       that was set with the \"-paths_relative_to\" switch"
  puts "                       when this script was generated.\n"
  puts "\[--help\]               Print help information for this script"
  puts "-------------------------------------------------------------------------\n"
  exit 0
}

if { $::argc > 0 } {
  for {set i 0} {$i < [llength $::argc]} {incr i} {
    set option [string trim [lindex $::argv $i]]
    switch -regexp -- $option {
      "--origin_dir" { incr i; set origin_dir [lindex $::argv $i] }
      "--help"       { help }
      default {
        if { [regexp {^-} $option] } {
          puts "ERROR: Unknown option '$option' specified, please type '$script_file -tclargs --help' for usage info.\n"
          return 1
        }
      }
    }
  }
}

# Set the directory path for the original project from where this script was exported
set orig_proj_dir "[file normalize "$origin_dir/"]"

# Create project
create_project DAC-FPGA ./DAC-FPGA -part xc7z020clg484-1

# Set the directory path for the new project
set proj_dir [get_property directory [current_project]]

# Reconstruct message rules
# None

# Set project properties
set obj [get_projects DAC-FPGA]
set_property "board_part" "em.avnet.com:zed:part0:0.9" $obj
set_property "default_lib" "xil_defaultlib" $obj
set_property "ip_cache_permissions" "read write" $obj
set_property "ip_output_repo" "/home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.cache/ip" $obj
set_property "sim.ip.auto_export_scripts" "1" $obj
set_property "xpm_libraries" "XPM_CDC XPM_MEMORY" $obj
set_property "xsim.array_display_limit" "64" $obj
set_property "xsim.trace_limit" "65536" $obj

# Create 'sources_1' fileset (if not found)
if {[string equal [get_filesets -quiet sources_1] ""]} {
  create_fileset -srcset sources_1
}

# Set IP repository paths
set obj [get_filesets sources_1]
set_property "ip_repo_paths" "[file normalize "$origin_dir/../ip_repo/SD_DAC_2.0"] [file normalize "$origin_dir/../ip_repo/SD_DAC_1.0"] [file normalize "$origin_dir/../ip_repo/SD_DAC_1.0"]" $obj

# Rebuild user ip_repo's index before adding any source files
update_ip_catalog -rebuild

# Set 'sources_1' fileset object
set obj [get_filesets sources_1]
set files [list \
 "[file normalize "$origin_dir/DAC-FPGA.srcs/sources_1/bd/DacFpga/DacFpga.bd"]"\
 "[file normalize "$origin_dir/DAC-FPGA.srcs/sources_1/bd/DacFpga/hdl/DacFpga_wrapper.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage1.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage3.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage5.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage4.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage2.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage6.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_stage7.v"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt.v"]"\
 "[file normalize "$origin_dir/../SDmod/SDmod.sv"]"\
 "[file normalize "$origin_dir/../DAC/dac.sv"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/tb_if.sv"]"\
 "[file normalize "$origin_dir/../HdlFilterOpt/casfilt_tb.v"]"\
 "[file normalize "$origin_dir/../SDmod/tb_SDmod.sv"]"\
 "[file normalize "$origin_dir/../SDmod/casfilt_tb.v"]"\
]
add_files -norecurse -fileset $obj $files

# Set 'sources_1' fileset file properties for remote files
set file "$origin_dir/DAC-FPGA.srcs/sources_1/bd/DacFpga/DacFpga.bd"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
if { ![get_property "is_locked" $file_obj] } {
  set_property "generate_synth_checkpoint" "0" $file_obj
}

set file "$origin_dir/../HdlFilterOpt/casfilt_stage1.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage3.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage5.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage4.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage2.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage6.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_stage7.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../SDmod/SDmod.sv"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "file_type" "SystemVerilog" $file_obj
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../DAC/dac.sv"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "file_type" "SystemVerilog" $file_obj
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/tb_if.sv"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "file_type" "SystemVerilog" $file_obj
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../HdlFilterOpt/casfilt_tb.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../SDmod/tb_SDmod.sv"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "file_type" "SystemVerilog" $file_obj
set_property "is_enabled" "0" $file_obj

set file "$origin_dir/../SDmod/casfilt_tb.v"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sources_1] [list "*$file"]]
set_property "is_enabled" "0" $file_obj


# Set 'sources_1' fileset file properties for local files
# None

# Set 'sources_1' fileset properties
set obj [get_filesets sources_1]
set_property "top" "DacFpga_wrapper" $obj

# Create 'constrs_1' fileset (if not found)
if {[string equal [get_filesets -quiet constrs_1] ""]} {
  create_fileset -constrset constrs_1
}

# Set 'constrs_1' fileset object
set obj [get_filesets constrs_1]

# Add/Import constrs file and set constrs file properties
set file "[file normalize "$origin_dir/DAC-FPGA.srcs/constrs_1/new/DAC_PL_clock.xdc"]"
set file_added [add_files -norecurse -fileset $obj $file]
set file "$origin_dir/DAC-FPGA.srcs/constrs_1/new/DAC_PL_clock.xdc"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets constrs_1] [list "*$file"]]
set_property "file_type" "XDC" $file_obj

# Set 'constrs_1' fileset properties
set obj [get_filesets constrs_1]
set_property "target_constrs_file" "$orig_proj_dir/DAC-FPGA.srcs/constrs_1/new/DAC_PL_clock.xdc" $obj

# Create 'sim_1' fileset (if not found)
if {[string equal [get_filesets -quiet sim_1] ""]} {
  create_fileset -simset sim_1
}

# Set 'sim_1' fileset object
set obj [get_filesets sim_1]
set files [list \
 "[file normalize "$origin_dir/../DAC/tb_dac.sv"]"\
]
add_files -norecurse -fileset $obj $files

# Set 'sim_1' fileset file properties for remote files
set file "$origin_dir/../DAC/tb_dac.sv"
set file [file normalize $file]
set file_obj [get_files -of_objects [get_filesets sim_1] [list "*$file"]]
set_property "file_type" "SystemVerilog" $file_obj


# Set 'sim_1' fileset file properties for local files
# None

# Set 'sim_1' fileset properties
set obj [get_filesets sim_1]
set_property "top" "tb_dac" $obj
set_property "transport_int_delay" "0" $obj
set_property "transport_path_delay" "0" $obj
set_property "xelab.nosort" "1" $obj
set_property "xelab.unifast" "" $obj

# Create 'synth_1' run (if not found)
if {[string equal [get_runs -quiet synth_1] ""]} {
  create_run -name synth_1 -part xc7z020clg484-1 -flow {Vivado Synthesis 2016} -strategy "Vivado Synthesis Defaults" -constrset constrs_1
} else {
  set_property strategy "Vivado Synthesis Defaults" [get_runs synth_1]
  set_property flow "Vivado Synthesis 2016" [get_runs synth_1]
}
set obj [get_runs synth_1]

# set the current synth run
current_run -synthesis [get_runs synth_1]

# Create 'impl_1' run (if not found)
if {[string equal [get_runs -quiet impl_1] ""]} {
  create_run -name impl_1 -part xc7z020clg484-1 -flow {Vivado Implementation 2016} -strategy "Vivado Implementation Defaults" -constrset constrs_1 -parent_run synth_1
} else {
  set_property strategy "Vivado Implementation Defaults" [get_runs impl_1]
  set_property flow "Vivado Implementation 2016" [get_runs impl_1]
}
set obj [get_runs impl_1]
set_property "steps.write_bitstream.args.readback_file" "0" $obj
set_property "steps.write_bitstream.args.verbose" "0" $obj

# set the current impl run
current_run -implementation [get_runs impl_1]

puts "INFO: Project created:DAC-FPGA"
